import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.*;

/**
 * La clase Letra son todos los objetos con texto que aparecen al momento que se estan jugando.
 * 
 * @author Ulises Yamil Castorena Caldera
 * @version 1.0
 */
public class Letra extends Actor
{
    private GreenfootImage img;//Variable que va a contener la imagen.
    
    /**
     * Constructor para la clase cadena, unicamente se crea el objeto y lo muestra.
     * @param valor Es la cadena que se mostrara.
     */
    public Letra(String valor)    
    {
        img = new GreenfootImage(valor,20,Color.BLACK,Color.WHITE);
        setImage(img);
    }
    
    /**
     * Constructor para la clase cadena, pero a diferencia del otro constructor en este, se convierte un entero a cadena y lo muestra en el objeto.
     * @param valor Es el entero que se va a convertir en cadena.
     */
    public Letra(int valor)
    {
        img = new GreenfootImage("NIVEL " + Integer.toString(valor),30,Color.WHITE,Color.BLACK);
        setImage(img);
    }
    
    /**
     * Método Act de la clase Letra que solamente muetra el objeto.
     */
    public void act() 
    {
        setImage(img);
    }    
}
