import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Clase donde se crean los objetos relacionados con la ayuda, el boton de acceso y el de regreso.
 * 
 * @author Ulises Yamil Castorena Caldera
 * @version 1.0
 */
public class LetraAy extends Ayuda
{
    private boolean tipo;//Variable que indica a cual de los dos de imagen se deben de crear.
    
    /**
     * Constructor de la clase, crea un objeto dependiendo del valor que recibe.
     * @param valor Segun sea su valor va a hacer el objeto a crear si es cero crea un objeto para acceder a la ayuda, sino crea un objeto para regresar de la ayuda.
     */
    public LetraAy(boolean valor)
    {
        tipo = valor;
        if(!tipo)
           img = new GreenfootImage("ay.png");
        else
        {            
           img = new GreenfootImage("return.png");
           img.scale(50,50);
        }
        setImage(img);
    }
    
    /**
     * Método Act el cual muestra la imagen y llama al método que verifica si se dio clic en el objeto.
     */
    public void act() 
    {
        setImage(img);
        verificaMouse();
    }    
    
    /**
     * Método que verifica en que clase de objeto se dio clic y dependiendo del objeto es su comportamiento.
     */
    public void verificaMouse()
    {   
        if(Greenfoot.mouseClicked(this))
        {
            if(!tipo)
            {
               getWorld().removeObjects(getWorld().getObjects(Portada.class));
               getWorld().removeObjects(getWorld().getObjects(Creditos.class));
               getWorld().addObject(new Ayuda(),400,200);
               getWorld().addObject(new LetraAy(true),640,320);
               getWorld().removeObject(this);
            }
            else
            {               
               ((Mundo)getWorld()).menu();
               getWorld().removeObject(this);
            }
        }
    }
}
