import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Clase que crea los objetos para poder acceder al juego desde la portada.
 * 
 * @author Ulises Yamil Castorena Caldera
 * @version 1.0
 */
public class LetraPort extends Portada
{
    private GreenfootImage play;//Variable que se va a utilizar para crear un objeto sonido.    
    private GreenfootSound son;//Variable que se va a utilizar para crear un objeto imagen.
    private boolean band;//Variable que indica en si se dio clic en el objeto.
    
    /**
     * Constructor de la clase, que inicializa las variables, aparte de crear el objeto imagen y el objeto sonido.
     */
    public LetraPort()
    {
         band = false;                  
         play = new GreenfootImage("play.png");         
         son = new GreenfootSound("Ferrari.mp3");
         setImage(play);        
    }
    
    /**
     * Método Act que muestra la imagen y llama a los Métodos que verifican si se dio clic en el objeto, si es asi, se manda un mensaje al mundo que indica que
     * debe de comenzar el juego.
     */
    public void act() 
    {         
         setImage(play);
         verificaMouse();
         if(!son.isPlaying() && band) 
            ((Mundo)getWorld()).comiezaJuego();         
    }
    
    /**
     * Verifica si se dio clic en este objeto y reproduce el objeto sonido y se incrementa band.
     */
    public void verificaMouse()
    {   
        if(Greenfoot.mouseClicked(this))
        {
            son.play();                    
            band = true;           
        }
    }
}
