import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.*;

/**
 * Clase que muestra el valor de las vidas actuales.
 * 
 * @author Ulises Yamil Castorena Caldera 
 * @version 1.0
 */
public class Vidas extends Actor
{
    private int vida;//Variable que contiene la cantidad total de vidas.
    private GreenfootImage img;//Variable que se va a utilizar para crear un objeto imagen.
    private GreenfootImage pierdev;//Variable que se va a utilizar para crear un objeto imagen.
    private GreenfootImage pierdef;//Variable que se va a utilizar para crear un objeto imagen.
    
    /**
     * Constructor para la clase vidas, en el se inicializa la cantidad total de vidas, ademas se convierte las vidas a cadena para poder mostrarlas.
     */
    public Vidas()
    {
        vida = 5;
        img = new GreenfootImage(Integer.toString(vida),20,Color.WHITE,Color.BLACK);
        setImage(img);
    }
    
    /**
     * Método Act de la clase, solamente muestra la imagen de la vida.
     */
    public void act() 
    {
        setImage(new GreenfootImage(Integer.toString(vida),20,Color.WHITE,Color.BLACK));
    }    
    
    /**
     * Método que disminuye una vida y realiza la validación si el usuario llega a cero vidas.
     */
    public void disminuyeVida()
    {
        vida --;
        if(vida <= 0)        
            ((Mundo)getWorld()).pierdes();        
    }    
}
